package com.example.barcodedemo;


import android.media.AudioManager;
import android.media.ToneGenerator;
import android.os.Bundle;
import android.app.Activity;
import android.app.NotificationManager;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.res.Resources;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.widget.EditText;
import android.widget.TextView;

public class MainActivity extends Activity {

	ToneGenerator mToneGen;
	private static Resources m_Res;
	boolean b_codeReader = false;
	NotificationManager m_ntfi = null;
	final int ID_LED=19831111;
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        m_Res = getResources();
        
        mToneGen = new ToneGenerator(AudioManager.STREAM_MUSIC, 100);
        EditText inputCodeEditText = (EditText)findViewById(R.id.editText_getCode);
        inputCodeEditText.setText("");
        
        //Key Code Begin: Register the filter to get the broadcast from BarcodeService
		IntentFilter filter = new IntentFilter();  
		filter.addAction(g_szSendDataBroadcastTag); 
		registerReceiver(m_BarcodeReaderReceiverGetData, filter);
		//End
	}
    
    //Key Code Begin: Sample code to get Barcode value
    public static final String g_szSendDataBroadcastTag = "BARCODESERVICE_SEND_BROADCAST";
    public static final String g_szSendDataTag = "BARCODESERVICE_SEND";
    private BroadcastReceiver m_BarcodeReaderReceiverGetData = new BroadcastReceiver()
    {
    	public void onReceive(Context context, Intent intent)
    	{
    		String action = intent.getAction();
    		if (g_szSendDataBroadcastTag.equals(action))
    		{
    			//szComData is the barcode value got by Broadcast
    			String  szComData = intent.getStringExtra(g_szSendDataTag);
    			EditText inputCodeEditText = (EditText)findViewById(R.id.editText_getCode);
    			inputCodeEditText.setText(szComData);
    		}
    	}
    };
    //End
    
    //Key Code Begin: Below two methods are must to make AP run correctly with getting Barcode value
	@Override
	protected void onResume() {
		super.onResume();
		
	}
	
	@Override
	protected void onStop() {
		super.onStop();
		
		unregisterReceiver(m_BarcodeReaderReceiverGetData);
		android.os.Process.killProcess(android.os.Process.myPid());
	}
	//End

  	@Override
	public void onDestroy() 
	{
	  	unregisterReceiver(m_BarcodeReaderReceiverGetData);
		super.onDestroy();
	}
  	
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
    
    //ⲿᴥonKeyDownkeyCodeͬԴͬKeyEvent
    //Sample code to get Up & Down & Barcode key events
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
    	super.onKeyDown(keyCode, event);
    	TextView tvTestName = (TextView)findViewById(R.id.textView2);

		Log.w(MainActivity.class.getName(), "onKeyDown() keyCode : " + keyCode);
		try{
        switch(keyCode)
        {
        	case KeyEvent.KEYCODE_VOLUME_UP://
        		tvTestName.setText(getStr(R.string.Volume_UP));
        		return true;
        	case KeyEvent.KEYCODE_VOLUME_DOWN://½
        		tvTestName.setText(getStr(R.string.Volume_down));
        		return true;
        	case KeyEvent.KEYCODE_UNKNOWN://ɨ谴
	            EditText inputCodeEditText = (EditText)findViewById(R.id.editText_getCode);
	            inputCodeEditText.setText("");
        		tvTestName.setText(getStr(R.string.strBarcode));
        		return true;
        	case KeyEvent.KEYCODE_BACK:
        		finish();
        		return true;
        }
        return false;
		}
		catch(Exception ex)
		{
    	    Log.w("Error in onKeyDown: %1$s", ex.toString());
    	    return false;
		}
    }
    
    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
    	super.onKeyUp(keyCode, event);
    	Log.w(MainActivity.class.getName(), "onKeyUp() keyCode : " + keyCode);
    	switch(keyCode)
    	{
    		case KeyEvent.KEYCODE_UNKNOWN:
    			return true;
    	}
    	return false;
    }
    
    private String getStr(int nStringID)
    {
    	try{
    		return m_Res.getString(nStringID);
    	}
    	catch(Exception ex)
    	{
    	    Log.w("Error in getStr: %1$s", ex.toString());
    	    return null;
    	}
    }
    

}