package com.example.CodeScan;

import com.example.CodeScan.R;
import com.example.CodeScan.util.SystemUiHider;

import android.app.Activity;

import android.os.Bundle;

import android.view.KeyEvent;
import android.view.View;
import android.widget.TextView;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;



/**
 * An example full-screen activity that shows and hides the system UI (i.e.
 * status bar and navigation/system bar) with user interaction.
 * 
 * @see SystemUiHider
 */
public class MainActivity extends Activity {
    
	public static final String ACTION_BCR_TRIGGER = "oem.android.bcr.ACTION_BCR_TRIGGER";
	public static final String ACTION_BCR_TRIGGER_KEYCODE = "oem.android.bcr.ACTION_BCR_TRIGGER_KEYCODE";
	public static final String ACTION_FEEDBACK = "oem.android.bcr.ACTION_FEEDBACK";
	/**
	 * The flags to pass to {@link SystemUiHider#getInstance}.
	 */
	private static final int HIDER_FLAGS = SystemUiHider.FLAG_HIDE_NAVIGATION;

	/**
	 * The instance of the {@link SystemUiHider} for this activity.
	 */
	private SystemUiHider mSystemUiHider;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.activity_main);
         
		//final View controlsView = findViewById(R.id.fullscreen_content_controls);
		final View contentView = findViewById(R.id.fullscreen_content);
		// Set up an instance of SystemUiHider to control the system UI for
		// this activity.
		mSystemUiHider = SystemUiHider.getInstance(this, contentView,HIDER_FLAGS);
		
		TextView codetextview = (TextView)contentView;
		codetextview.setText("MIO BarCode Sample");	
		
        IntentFilter filter = new IntentFilter();  
        filter.addAction(ACTION_FEEDBACK); 
        filter.addAction(ACTION_BCR_TRIGGER); 
        registerReceiver(mCodeScanReceiver, filter); 

		// Set up the user interaction to manually show or hide the system UI.
		contentView.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				SendBcrIntent();
			}
		});
	}
	
    public void SendBcrIntent()
    {
        Intent intent = new Intent(ACTION_BCR_TRIGGER); 
        intent.putExtra(ACTION_BCR_TRIGGER_KEYCODE, 118); 
        sendBroadcast(intent);             
    }
    
    public BroadcastReceiver mCodeScanReceiver = new BroadcastReceiver() {
    	
    	@Override
    	public void onReceive(Context context, Intent intent){
            if (intent.getAction().equals(ACTION_FEEDBACK))
            { 
        		String  szComData = intent.getStringExtra(Intent.EXTRA_TEXT);
        		TextView codetextview= (TextView)findViewById(R.id.fullscreen_content);
        		codetextview.setText(szComData);
            }
            if (intent.getAction().equals(ACTION_BCR_TRIGGER))
            {
        		TextView codetextview = (TextView)findViewById(R.id.fullscreen_content);
        		codetextview.setText("MIO BarCode Sample");	
            }
    	}
    };
    
    @Override
	public void onDestroy() 
	{
	    unregisterReceiver(mCodeScanReceiver);
	    super.onDestroy();
	}
	
	@Override
	protected void onPostCreate(Bundle savedInstanceState) {
		super.onPostCreate(savedInstanceState);
		// Trigger the initial hide() shortly after the activity has been
		// created, to briefly hint to the user that UI controls
		// are available.
		
		mSystemUiHider.show();
	}
	
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        super.onKeyDown(keyCode, event);

        try{
        switch(keyCode)
        {
            case KeyEvent.KEYCODE_VOLUME_UP://
            	SendBcrIntent();
                return true;
                
            case KeyEvent.KEYCODE_VOLUME_DOWN://½
   
                return true;
                
            case KeyEvent.KEYCODE_UNKNOWN://ɨ谴
        		TextView codetextview = (TextView)findViewById(R.id.fullscreen_content);
        		codetextview.setText("MIO BarCode Sample");	
                return true;
                
            case KeyEvent.KEYCODE_BACK:

                return true;
        }
        
        return false;
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            return false;
        }
    }
}